Subject: Re: wrong handling of text git attribute leading to files incorrectly reported as modified

From: Torsten Bögershausen <[email-masked]>
Date: Fri, 11 Apr 2014 22:38:44 +0200

On 2014-04-11 22.20, Frank Ammeter wrote:
> I’m not a git expert and this might be the wrong place to ask this question,
> so please send me somewhere else if I’m in the wrong place.
> 
> I asked the same question on stack overflow, but didn’t get any response:
> http://stackoverflow.com/questions/22823004/files-incorrectly-reported-modified-git-attributes-buggy-leading-to-inconsist
> 
> If a file is committed with crlf line endings with the text attribute unset in the working tree, but the text attribute is set in the repo, the file will be incorrectly shown as modified - for all users checking out the file.
> Resetting or manually modifying the file will not help - The only remedy is to commit the .gitattributes with the text attribute set for the file.
> 
> Wouldn’t it be better to only consider the checked-in gitattributes instead of the attributes in the working tree?
No.
If you change stuff in your working tree (and .gitattributes is a part of the working tree)
how should Git know what you want?
The primary assumption is that you know what you are doing in the working tree.
> Is this a bug in git handling gitattributes or is this wrong usage? 
I thinkk No, yes.

If it is wrong usage, is it documented anywhere?
Please have a look here:
https://www.kernel.org/pub/software/scm/git/docs/gitattributes.html

And if you think that the documentation can be improved,
please feel free to send suggestions.

A simple "git diff" is a good start, and a patch with a commit message is even better.